#ifndef _WSCCONF_TXT_H
#define _WSCCONF_TXT_H

char *wsc_config[] =
{ "# Simple Config Configuration File\n",
  "# Lines that start with # are treated as comments\n",
  "# Each line should not exceed 80 characters\n",
  "# Format: TYPE=value\n",
  "#\n",
  "# Configured Mode: 1=Unconfigured AP, 2=Client, 3=Registrar,\n",
  "# 4=AP with Proxy, 5 = AP with Proxy and Registrar\n",
  "CONFIGURED_MODE=5\n",
  "# Is the standalone Registrar (mode 3) wireless-enabled\n",
  "# Yes: 1, No:0\n",
  "REGISTRAR_WIRELESS=0\n",
  "# Should UPnP be used (for modes 1 and 3)\n",
  "# Yes: 1, No:0\n",
  "USE_UPNP=1\n",
  "UUID=0x565aa94967c14c0eaa8ff349e6f59311\n",
  "VERSION=0x10\n",
  "DEVICE_NAME=Atheros AP\n",
  "# Primary Device Categories: Please refer to the SC spec for\n",
  "# values for the following types\n",
  "PRI_DEV_CATEGORY=6\n",
  "PRI_DEV_OUI=0x50f204\n",
  "PRI_DEV_SUB_CATEGORY=1\n",
  "# MAC Address of the local device, 6 byte value\n",
  "MAC_ADDRESS=0x00037f0964f4\n",
  "MANUFACTURER=Atheros\n",
  "MODEL_NAME=Sample String 1\n",
  "MODEL_NUMBER=1234\n",
  "SERIAL_NUMBER=5678\n",
  "# Config Methods: bitwise OR of values \n",
  "CONFIG_METHODS=0x84\n",
  "# Auth type flags: bitwise OR of values \n",
  "AUTH_TYPE_FLAGS=0x",
  "# Encr type flags: bitwise OR of values \n",
  "ENCR_TYPE_FLAGS=0x",
  "CONN_TYPE_FLAGS=0x1\n",
  "RF_BAND=3\n",
  "OS_VER=0x80000000\n",
  "FEATURE_ID=0x80000000\n",
  "# SSID:\n",
  "# For unconfigured client: What it should connect to when\n",
  "# starting EAP-WSC\n",
  "# Example: SSID=WscSecureAP\n",
  "# For unconfigured AP: Initial broadcast SSID\n",
  "# Example: SSID=WscNewAP\n",
  "# For Registrar: SSID that the supplicant must connect to when\n",
  "# starting EAP-WSC\n",
  "# Example: SSID=WscNewAP\n",
  "# For AP with Registrar: Broadcast SSID\n",
  "# Example: SSID=WscSecureAP\n",
  "SSID=",
  "# Key Mgmt for Supplicant (Client, Registrar):\n",
  "# Unconfigured, doing WSC: WPA-EAP IEEE8021X\n",
  "# Configured after WSC (will be done by the s/w): WPA-PSK\n",
  "# Key Mgmt for Hostapd (AP, AP with Registrar):\n",
  "# Unconfigured, doing WSC: WPA-EAP\n",
  "# Configured after WSC (will be done by the s/w): WPA-PSK\n",
  "# Configured, plus Registrar: WPA-EAP WPA-PSK\n",
  "KEY_MGMT=",
  "# Are we using a USB key to transfer PIN/Credential?\n",
  "# Yes: 1, No:0\n",
  "USB_KEY=0\n",
  "# Is the Network Key set?\n",
  "# Yes: 0xValue or passphrase, No: comment out line\n",
  "# NW_KEY=0x000102030405060708090A0B0C0D0E0F000102030405060708090A0B0C0D0E0F\n",
  "# NW_KEY=passphrase\n",
  "NW_KEY=",
  "# DBG_LEVEL bit mask: 0:ERR, 1:INFO, 2:REG, 3:UPNP, 4:MC, 16:DBG\n",
  "DBG_LEVEL=7\n",
};

#endif

